/* 
 * CSE142, Spring 1999
 * Homework 4
 
   Title:  TOADER
   Date: 5/20/99
   Author:		Damon Hachmeister
   Section AF
   E-Mail:      damonh@u.washington.edu

		******COMMENTS********

  2 things that went wrong but I didn't fix because I liked them:

  1.)  Score constantly runs while TOADER is in the street.....oh well.  You
  get points for dodging traffic.

  2.)  The flying cars after level 11.  I have no idea where they came from
  but they're good to dodge.

 *
 *
 */   

#include "gp142.h"
#include <stdio.h>
#include <math.h>
#include <time.h>

	/* 
	* <time.h> is included so the current time can be accessed
	* to initialize the random number generator.  If you don't
	* use random numbers (and you don't have to) you can either
	* ignore this #include or delete it.
	*/

/* Logical constants */
#define TRUE    		1
#define FALSE   		0

/* 
 * For many of the GP142 functions, a line width of
 * zero means to fill the shape being drawn.  The
 * constant FILL is used in function calls when a solid
 * shape is desired.
 */
#define FILL 0


/*
 * Symbolic constants.  Change as needed.
 */

/* Menu buttons: */

/* Top-left coordinates of button palette */
#define MENU_TOP		(GP142_YMAX - 5)
#define MENU_LEFT		(-GP142_XMAX + 5)

/* Height and width of buttons in pixels */
#define BUTTON_HEIGHT  	25
#define BUTTON_WIDTH 	75

/* Number of buttons */
#define NUM_BUTTONS 	6


/* Possible locations of mouse clicks: */

/*   Mouse click in some button */
#define BUTTON_CLICK 1

/*   Mouse click elsewhere */
#define OTHER_CLICK 0


/* Coordinates of objects in the drawing */

/* y-coordinate of the top of the ground in the landscape */
#define HORIZON (- 2 * (GP142_YMAX / 10))

/* Vertical center and width of highway */
#define HIGHWAY_CENTER ((-GP142_YMAX + HORIZON) / 3)
#define HIGHWAY_WIDTH  10


/* Maximum number of vehicles that can appear in the animation */
#define MAX_VEHICLES	1

/* Height and width of a single car */
#define CAR_HEIGHT 24
#define CAR_WIDTH  40

/* Height and color of grog */
#define FROG_HEIGHT 25
#define FROG_COLOR GREEN

/*****************************************************************************

     FUNCTION PROTOTYPES

*****************************************************************************/

/* Initialize random number generator.  [Ignore or		*/
/* remove if your program doesn't use random numbers.]	*/
void initialize_random_numbers();

/* Draw the background, including the sun at coordinates sun_x and sun_y */
void draw_landscape(int sun_x, int sun_y);

/* Draw the buttons */
void draw_buttons();

/* Return kind of mouse click (in a button, etc.) */
int  classify_mouse_click(int mouse_x, int mouse_y);

/* Process button click at location x, y.  Update car speed,  */
/* direction, color, and whether traffic is moving as needed. */
void handle_button(int x, int y, int *traffic_moving, int *car_speed,
				   int *car_direction, int *car_color);

/* Update sun coordinates sun_x, sun_y for one tick */
void move_sun(int *sun_x, int *sun_y);

/* Update all vehicle x, y coordinates, given current x, y */
/* location, direction (+1 or -1), and speed in pixels per tick. */
void move_traffic(int *x, int *y, int *direction, int speed);

/* Draw all vehicles given their current x, y coordinates and color */
void draw_traffic(int x, int y, int color);

/* Draw a single car of the given color with horizontal */
/* center x and bottom y*/
void draw_car(int x, int y, int color);

/* Frog junk */
void draw_frog(int frog_x, int frog_y);
void move_frogX(int *X, char holderii);
void move_frogY(int *Y, char holder, int*level);

/* Draw graveyard if frog is crushed */
void draw_graveyard();

/* Display error message if internal error is detected. */
void something_is_wrong (void);

/* functions for keeping track of and displaying the current score */
int score_function(int frog_y);
void print_score(int score);

/* Draws lives left in the lower right corner */
void draw_lives_left(int lives);

void draw_directions(void);
/*****************************************************************************

     MAIN

*****************************************************************************/

/*
 * Main program contents:
 *   - Major program variables that persist throughout execution
 *   - Event loop that processes GP142 events until the user quits,
 *     and updates variables and redraws the window as needed.
 */
int main(void)
{
	/* Event handling and buttons: */
	int  quit;				/* = "user has selected quit"				*/
	int  event;				/* the most recent GP142 event				*/
	char key_pressed;		/* last keyboard character from key event	*/
	int  mouse_x, mouse_y;	/* x and y coordinates of latest mouse event*/
	int  click_kind;		/* kind of mouse click (button, etc.)		*/
	
	/* Information about the sun: */
	int sun_x, sun_y;			/* screen x and y coordinates */

	/* Information about vehicles in the animation:							*/
	/* [Only one car now - will need to be changed to add more]				*/
	int car_x, car_y;		/* current position of the car					*/
	int car_direction;
	
	/* current direction: +1=right, -1=left			*/
	int car_color;			/* color of the car								*/
	int car_speed;
	

	/* speed in pixels per tick when traffic moving	*/	
	int traffic_moving;		/* = "traffic is currently moving" */
	
	/* info for cars */
	int car_speed_2[] = {15, 9, 29, 6, 7, 20, 29, 15, 8, 13, 11, 13, 2, 15, 32,
		13,14,15};			
	int car_x_2[] = {GP142_XMAX - 30, 0, GP142_XMAX - 60, 0, 0, 0, 
		GP142_XMAX - 50, -GP142_XMAX + 30, GP142_XMAX - 120, 0, 0, 0,
		GP142_XMAX - 30, -GP142_XMAX + 30, 0, 0,GP142_XMAX - 50,
		-GP142_XMAX + 30};
	int car_y_2[] = {HIGHWAY_CENTER -30, HIGHWAY_CENTER - 90, HIGHWAY_CENTER - 60,
		HIGHWAY_CENTER + 30, HIGHWAY_CENTER, HIGHWAY_CENTER - 60, HIGHWAY_CENTER - 90,
		HIGHWAY_CENTER + 30, HIGHWAY_CENTER - 90, HIGHWAY_CENTER - 30,
		HIGHWAY_CENTER + 30, HIGHWAY_CENTER, HIGHWAY_CENTER - 60, HIGHWAY_CENTER - 90,
		HIGHWAY_CENTER + 30, HIGHWAY_CENTER - 90, HIGHWAY_CENTER - 30,HIGHWAY_CENTER + 30};
	int car_color_2[] = {BLUE, OLIVE, YELLOW, BROWN, ORANGE, GREEN, OLIVE, BLACK,
		ORANGE, RED, YELLOW, BLACK, BLUE, OLIVE, YELLOW,BLUE, OLIVE, YELLOW};
	

	int l;  /* counter for going through car arrays */
	int frog_x, frog_y;   /*  frog's current coordinates */
			
	int score, score_total = 0, keep_score;
	int lives = 3;
	int level = 1;
	int play_again;
	
	/********************************************************************************/
	
	initialize_random_numbers();
	
	/* Initialize graphics package, clear the window,	*/
	/* turn logging off, and start animation.			*/
	GP142_open();
	GP142_logging(LOG_OFF);
	GP142_clear();
	GP142_animate(ANI_RUN);

	/* set initial location of the sun */
	sun_x = GP142_XMAX - 50;
	sun_y = GP142_YMAX - 35;

	/* set initial location of the frog */
	frog_x = 0;
	frog_y = HIGHWAY_CENTER - 120;

	/* set initial conditions for the car */
	
	car_x = 0;
	car_y = HIGHWAY_CENTER;
	car_speed = 5;
	car_direction = +1;
	car_color = RED;

	/*  score initialization */	
	score = 0;
	
	
	traffic_moving = TRUE;
	play_again = 1;
	
	/* Draw initial landscape, buttons, and traffic */
	
	while (play_again == 1) {
	
	draw_landscape(sun_x,sun_y);
	draw_frog(frog_x, frog_y);
	draw_buttons( );
	draw_traffic(car_x, car_y, car_color);
	draw_lives_left(lives);
	draw_directions();
	keep_score = 0;
	score = score_function(frog_y);
	score_total += score;
	print_score(score_total);
	for (l=0; l < (level + 4); l++)  {
		draw_traffic(car_x_2[l], car_y_2[l], car_color_2[l]);
	}

	/*
	 * Main event loop:
	 * ---- ----- -----
	 * Wait for the next user action, decode it, and call an
	 * appropriate function to handle it.  Repeat until the
	 * user selects quit.
	 */
	quit = FALSE;
	while (!quit) {
		
		/* get next event */
		event = GP142_await_event(&mouse_x, &mouse_y, &key_pressed);
		
		/* perform appropriate action depending on kind of event */
		switch (event) {
		case GP142_QUIT:
			/* Quit selected */
			quit = TRUE;
			break;
			
		case GP142_KBD:
			 
			if (traffic_moving == TRUE)  {  
				if (key_pressed == 'i' || key_pressed == 'm')  
					move_frogY(&frog_y, key_pressed, &level);
					if (key_pressed == 'j' || key_pressed == 'k')
						move_frogX(&frog_x, key_pressed);
			}
			
			break;
			
		case GP142_MOUSE:
			/* Mouse click.  Determine if in a menu button	*/
			/* or elsewhere and process accordingly.		*/
			click_kind = classify_mouse_click(mouse_x, mouse_y);
			if (click_kind == BUTTON_CLICK) {
				handle_button(mouse_x, mouse_y, &traffic_moving, &car_speed,
								&car_direction, &car_color);
			} else {
				/* insert code here (and additional else-if statements) */
				/* to react to mouse clicks elsewhere on the screen */
				}
			break;
			
		case GP142_PERIODIC:
			/* Timer interval event.  Update everything	*/
			/* that needs to change as time advances.	*/
			move_sun(&sun_x, &sun_y);
			if (traffic_moving) {
				move_traffic(&car_x, &car_y, &car_direction, car_speed);
				for (l = 0; l < (level + 4); l++)  {
					move_traffic(&car_x_2[l], &car_y_2[l], &car_direction, car_speed_2[l]);
				}
			}
			break;
			
		default:
			/* unknown event */
			break;
			
		}  /*end switch */
		
		/* Redraw everything */
		
		
		draw_landscape(sun_x, sun_y);
	
		/* Checks to see if a car and the frog are touching */
		if (abs(frog_x - car_x) <= FROG_HEIGHT && abs(frog_y - car_y) <= FROG_HEIGHT)  {
			traffic_moving = FALSE;
			keep_score = 1;    /*stops score counting*/
			lives -=1;
			draw_graveyard();
			if (lives == 0)  {
				return (0);
			}
			/*  resets frog, starts up traffic and starts scoring again */
			frog_x = 0;
			frog_y = HIGHWAY_CENTER - 120;
			keep_score = 0;
			traffic_moving = TRUE;
		}
		/* same as above but for car arrays */
			for (l = 0; l < (level + 4); l++)  {
				if (abs(frog_x - car_x_2[l]) <= FROG_HEIGHT && abs(frog_y -car_y_2[l]) <= FROG_HEIGHT) {
					traffic_moving = FALSE;
					keep_score = 1;
					lives -=1;
					draw_graveyard();
					
					if (lives == 0)  {
					/*insert play again question */
						return (0);
					}
					frog_x = 0;
					frog_y = HIGHWAY_CENTER - 120;
					keep_score = 0;
					traffic_moving = TRUE;
				}
			}
		
		draw_frog(frog_x, frog_y);
		draw_buttons();
		draw_traffic(car_x, car_y, car_color);
		draw_lives_left(lives);
		draw_directions();
		
		/* Causes score to increase with time spent in street */
		score = score_function(frog_y);
		score_total += score;
		if (keep_score == 0)  {
			score_function(frog_y);
			print_score(score_total);
		}
		
		for (l=0; l< (level + 4); l++)  {
			draw_traffic(car_x_2[l], car_y_2[l], car_color_2[l]);
		}
		GP142_printfXY(BLACK, GP142_XMAX - 150, GP142_YMAX - 50, 15, "level :%d", level);
	}  /* end event loop */
	
	}	
	/* Termination: shut down graphics window and exit */
	GP142_close();
	return 0;
}  /*end main */


/*****************************************************************************

     BACKGROUND LANDSCAPE

*****************************************************************************/


/* Draw the background, including the sun at coordinates sun_x and sun_y */
void draw_landscape(int sun_x, int sun_y)
{
	int text_offset = -GP142_XMAX + 15;	/* horizontal offset of text */
	int text_size   = 12;				/* size of text font */
	
	/* Draw the sky */
	
	GP142_rectangleXY(ICE_BLUE, -GP142_XMAX, -GP142_YMAX,
		GP142_XMAX, GP142_YMAX, FILL);

	/* Draw the sun */
	GP142_circleXY(YELLOW, sun_x, sun_y , 20);



	/* Draw the ground, highway, and text legend */
	GP142_rectangleXY(BROWN, -GP142_XMAX, -GP142_YMAX,
		GP142_XMAX, HORIZON, FILL);
		
		/* Top Road */
	GP142_rectangleXY(WHITE, 
					-GP142_XMAX, HIGHWAY_CENTER + 40,
					 GP142_XMAX, HIGHWAY_CENTER + 20,
					 FILL);
	GP142_lineXY(BLACK, -GP142_XMAX, HIGHWAY_CENTER + 30, GP142_XMAX,
		HIGHWAY_CENTER + 30, 1);
	
	/*2nd Road down*/
	
		GP142_rectangleXY(WHITE, 
					-GP142_XMAX, HIGHWAY_CENTER - HIGHWAY_WIDTH,
					 GP142_XMAX, HIGHWAY_CENTER + HIGHWAY_WIDTH,
					 FILL);
	GP142_lineXY(BLACK, -GP142_XMAX, HIGHWAY_CENTER, GP142_XMAX,
		HIGHWAY_CENTER, 1);

	/*3rd Road down*/
	GP142_rectangleXY(WHITE, 
					-GP142_XMAX, HIGHWAY_CENTER - 20,
					 GP142_XMAX, HIGHWAY_CENTER - 40,
					 FILL);
	GP142_lineXY(BLACK, -GP142_XMAX, HIGHWAY_CENTER - 30, GP142_XMAX,
		HIGHWAY_CENTER - 30, 1);

	/*4th Road down*/
	GP142_rectangleXY(WHITE, 
					-GP142_XMAX, HIGHWAY_CENTER - 50,
					 GP142_XMAX, HIGHWAY_CENTER - 70,
					 FILL);
	GP142_lineXY(BLACK, -GP142_XMAX, HIGHWAY_CENTER - 60, GP142_XMAX,
		HIGHWAY_CENTER - 60, 1);

			/*Bottom Road*/
	GP142_rectangleXY(WHITE, 
					-GP142_XMAX, HIGHWAY_CENTER - 80,
					 GP142_XMAX, HIGHWAY_CENTER - 100,
					 FILL);
	GP142_lineXY(BLACK, -GP142_XMAX, HIGHWAY_CENTER - 90, GP142_XMAX,
		HIGHWAY_CENTER - 90, 1);


	
	/*Draw some mountains */
	GP142_triangleXY(MED_GRAY,
		-GP142_XMAX, HORIZON,
		GP142_XMAX, HORIZON,
		0, (4 * GP142_YMAX)/5 ,
		FILL);
	
	GP142_triangleXY(OLIVE,
		-( 5 * GP142_XMAX/4), HORIZON,
		(GP142_XMAX)/3  , HORIZON,
		-(3* GP142_XMAX)/4, (2 * GP142_YMAX)/3 ,
		FILL);
	
	GP142_triangleXY(FOREST_GREEN,
		-GP142_XMAX / 3 , HORIZON,
		GP142_XMAX, HORIZON,
		GP142_XMAX, (2 * GP142_YMAX)/3 ,
		FILL);

				/* Frog safe areas */
	GP142_rectangleXY(BLACK, 
					-GP142_XMAX, HIGHWAY_CENTER - 110,
					 GP142_XMAX, HIGHWAY_CENTER - 130,
					 FILL);
	GP142_rectangleXY(BLACK,
					-GP142_XMAX, HIGHWAY_CENTER + 70,
					 GP142_XMAX, HIGHWAY_CENTER + 50,
					 FILL);
} /*end draw_landscape */


/*****************************************************************************

     BUTTONS AND MOUSE CLICKS

*****************************************************************************/


/* Draws the buttons */
void draw_buttons( )
{
	int i;
	int text_offset = MENU_LEFT+10;	/* offset of button text in button */
	int font_size = 12;				/* size of button text */
	
	/* draw rectangles for each button */
	for(i = 0; i < NUM_BUTTONS; i++) {
		GP142_rectangleXY(BLACK,
			MENU_LEFT,
			MENU_TOP - i * BUTTON_HEIGHT,
			MENU_LEFT + BUTTON_WIDTH,
			MENU_TOP - (i + 1)*BUTTON_HEIGHT, 1);
	}
	
	/* display button text */
	i = MENU_TOP - (BUTTON_HEIGHT/2) - (font_size/2);
	GP142_printfXY(FOREST_GREEN, text_offset, i, font_size, "START");	
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(RED, text_offset, i, font_size, "PAUSE");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLACK, text_offset, i, font_size, "Faster");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLACK, text_offset, i, font_size, "Slower");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLACK, text_offset, i, font_size, "Reverse");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLACK, text_offset, i, font_size, "New Color");
	
}

/* Classify mouse click at (mouse_x,mouse_y) and return kind */
int  classify_mouse_click(int mouse_x, int mouse_y)
{
	if ((mouse_x > MENU_LEFT) &&
		(mouse_x < MENU_LEFT + BUTTON_WIDTH) &&
		(mouse_y < MENU_TOP) &&
		(mouse_y > (MENU_TOP - NUM_BUTTONS*BUTTON_HEIGHT)))
		return BUTTON_CLICK;
	else
		return OTHER_CLICK;
}



/* Process button click at location x, y.  Update car speed,	*/
/* direction, color, and whether traffic is moving as needed.	*/
void handle_button(int x, int y, int *traffic_moving, int *car_speed,
				   int *car_direction, int *car_color)
{
	int buttonNum;		/* number of selected button */

	/* Complain if x coordinate couldn't be inside a button */
	if (x < MENU_LEFT || x > MENU_LEFT + BUTTON_WIDTH) {
		something_is_wrong();
		return;
	}
	
	/* Convert y coordinate to button number from top. */
	buttonNum = (MENU_TOP - y)/BUTTON_HEIGHT;	 
	
	switch(buttonNum) {
	case 0:
		/* go */
		*traffic_moving = TRUE;
		break;
	case 1:
		/* stop */
		*traffic_moving = FALSE;
		break;
		
	case 2:
		/* speed up */
		*car_speed = *car_speed + 1;
		break;
	case 3:
		/* slow down */
		*car_speed = *car_speed - 1;
		if (*car_speed < 0)
			*car_speed = 0;
		break;
		
	case 4:
		/* reverse */
		*car_direction = - *car_direction;
		break;
	case 5:
		/* change car color */
		*car_color = (*car_color+1) % MAX_COLORS;
		break;
	default:
		/*Bad news if this is ever reached! */
		something_is_wrong();
		break;
	}
}

	/* running tally for score */
int score_function(int frog_y)  {
	int score1 = 0;
	score1 = (frog_y + 220)/10;
	return (score1);
}
	/* box and printf for score */
	
void print_score(int score)  {
	GP142_rectangleXY(BLACK, GP142_XMAX - 80, GP142_YMAX - 30, GP142_XMAX - 5,
		GP142_YMAX -5, FILL);
	GP142_printfXY(WHITE, GP142_XMAX -60, GP142_YMAX - 23, 14, "%d", score);
}
	

/*****************************************************************************

     TRAFFIC AND OTHER ANIMATED OBJECTS

*****************************************************************************/


/* Update sun coordinates sun_x, sun_y by one tick */
void move_sun(int *sun_x, int *sun_y) {
	/* Move the sun to the left.  If it reaches the edge, move it */
	/* to the other side and down a bit. */
	(*sun_x) --;
	if (*sun_x < -GP142_XMAX -30) {
		*sun_x = - *sun_x;
		(*sun_y) --;
	
	}
}

void move_frogX(int *X, char holder)  {
	/* move frog left */
	if (holder == 'j')  {
		if (*X > -GP142_XMAX + FROG_HEIGHT)
			*X = *X - FROG_HEIGHT;
	}
	/* move frog right */
	else if (*X < GP142_XMAX - FROG_HEIGHT)
		*X = *X + FROG_HEIGHT;
}

void move_frogY(int*Y, char holder, int*level)  {
	/*move frog up*/
	if (holder == 'i')  {
		if (*Y < HIGHWAY_CENTER + 60)
			*Y = *Y + 30;
		if (*Y == HIGHWAY_CENTER + 60) {
			*Y = HIGHWAY_CENTER - 120;
			*level+=1;
		}
	}
	/* move frog down */
	else if (*Y > HIGHWAY_CENTER - 120)
		*Y = *Y - 30;
}










/* Update all vehicle x, y coordinates, given current x, y */
/* location, direction (+1 or -1), and speed in pixels per tick, */
void move_traffic(int *x, int *y, int *direction, int speed) {
	/* Note: If there is more than one vehicle, this should */
	/* be updated to adjust all vehicle coordinates */

	int trial_x;		/* new value for x coordinate */

	/* move vehicle.  If it moves off the edge, reverse direction */
	trial_x = *x + (*direction * speed);
	if (abs(trial_x) > GP142_XMAX - CAR_WIDTH/2)
		*x = -*x;
	else
		*x = trial_x;
}


/* Draw all vehicles given their current x, y coordinates and color */
void draw_traffic(int x, int y, int color) {
	/* Note: needs to be changed if there is more than */
	/* one vehicle */

	draw_car(x,y,color);
}




/* Draw a single car of the given color with horizontal */
/* center x and bottom y*/
void draw_car(int x, int y, int color) {
	GP142_rectangleXY(color, x - CAR_WIDTH/2, y + CAR_HEIGHT/4,
						x + CAR_WIDTH/2, y + CAR_HEIGHT*3/4, FILL);
	GP142_rectangleXY(color, x - CAR_WIDTH/6, y + CAR_HEIGHT*3/4,
		x + CAR_WIDTH/6, y + CAR_HEIGHT, FILL);
		
	GP142_circleXY(BLACK, x - CAR_WIDTH/4, y + CAR_HEIGHT/4, CAR_HEIGHT/4);
	GP142_circleXY(BLACK, x + CAR_WIDTH/4, y + CAR_HEIGHT/4, CAR_HEIGHT/4);
}





void draw_frog(int frog_x, int frog_y)  {
	/*  Frog's body */
	GP142_circleXY(FROG_COLOR, frog_x, frog_y, FROG_HEIGHT/2);
	
	/*  Frog's feet */
	GP142_circleXY(BLACK, frog_x -FROG_HEIGHT/3, frog_y - (FROG_HEIGHT/5)*2, FROG_HEIGHT/5);
	GP142_circleXY(BLACK, frog_x +FROG_HEIGHT/3, frog_y - (FROG_HEIGHT/5)*2, FROG_HEIGHT/5);
	
	/*  Frog's head */
	GP142_circleXY(BLACK, frog_x, frog_y + (FROG_HEIGHT/12)*7, FROG_HEIGHT/2 - FROG_HEIGHT/15);
	GP142_circleXY(FROG_COLOR, frog_x, frog_y + (FROG_HEIGHT/12)*7, (FROG_HEIGHT/5)*2);
	
	/*  Frog's eyeballs */
	GP142_circleXY(WHITE, frog_x - FROG_HEIGHT/4, frog_y + (FROG_HEIGHT*4)/5, FROG_HEIGHT/4);
	GP142_circleXY(WHITE, frog_x + FROG_HEIGHT/4, frog_y + (FROG_HEIGHT*4)/5, FROG_HEIGHT/4);
	GP142_circleXY(BLACK, frog_x + FROG_HEIGHT/4, frog_y + (FROG_HEIGHT*4)/5, FROG_HEIGHT/15);
	GP142_circleXY(BLACK, frog_x - FROG_HEIGHT/4, frog_y + (FROG_HEIGHT*4)/5, FROG_HEIGHT/15);
	
	/*  Frog's mouth */
	GP142_lineXY(BLACK, frog_x - (FROG_HEIGHT/10)*3, frog_y + FROG_HEIGHT/2 - FROG_HEIGHT/10,
		frog_x + (FROG_HEIGHT/10)*3, frog_y + FROG_HEIGHT/2 - FROG_HEIGHT/10, FROG_HEIGHT/15);
}



void draw_graveyard()  {
	double holder;

		GP142_rectangleXY(BLACK, -GP142_XMAX, -GP142_YMAX, GP142_XMAX, GP142_YMAX, FILL);
		GP142_rectangleXY(MED_GRAY, -GP142_XMAX/3, -GP142_YMAX/2, GP142_XMAX/3, 
			GP142_YMAX/2, FILL);
		GP142_circleXY(MED_GRAY, 0, GP142_YMAX/2, (GP142_YMAX/12)*5);
	
		GP142_printfXY(WHITE, -GP142_XMAX/3 + 50, GP142_YMAX/2, 20, "YOU WERE");
		GP142_printfXY(WHITE, -GP142_XMAX/3 + 50, GP142_YMAX/2 - 40, 20, "CRUSHED!");
		draw_frog(-GP142_XMAX/3 + 100, GP142_YMAX/2 - 100);
		/*helps a bit, but any longer freezes*/
		for(holder=0;holder<999999;holder+=1)  {}
		for(holder=0;holder<999999;holder+=1)  {}
}

void draw_lives_left(int lives) {
	switch(lives) {
	
	case 3:
		draw_frog(GP142_XMAX - FROG_HEIGHT, -GP142_YMAX + 30);
		draw_frog(GP142_XMAX - FROG_HEIGHT*2, -GP142_YMAX + 30);
		break;
	case 2:
		draw_frog(GP142_XMAX - FROG_HEIGHT, -GP142_YMAX + 30);
		break;	
	}
}
	

/*****************************************************************************

     OTHER

*****************************************************************************/


/* Initialize random number generator */
/* [Ignore or delete if your program  */
/* doesn't user random numbers.] */
void initialize_random_numbers() {
	time_t t;			/* current time */
	srand (time(&t));
	
}
void draw_directions(void) {
	GP142_rectangleXY(WHITE, -100, GP142_YMAX - 15,
		100, GP142_YMAX - 5, FILL);
	GP142_printfXY(BLACK, -90, GP142_YMAX - 15,
		12, "i=up; j=left; k=right; m=down");
}

/* Display error message if internal error is detected. */
void something_is_wrong (void) {
	GP142_printfXY (RED, 0, 0, 16, "BAAAADDD NEWS!");
}
